
function C=FW_ADDTENSOR180323(A,B)
% C=FW_ADD_TENSOR(A,B)
% A = matrix of the exponents of the first polynomial
% B = matrix of the exponents of the second polynomial
% C = matrix of the exponents of the product of tensors of A by B 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Remove the column of zeros in A and B if necessary
if size(A,1)==1
    A=A';
end
if size(B,1)==1
    B=B';
end

A0=A;
B0=B;

a1=size(A0,1);
a2=size(A0,2);
b1=size(B0,1);
b2=size(B0,2);

C0=zeros(a1*b1, a2+b2);

ic=0;
for ia=1:a1
    C0(ic+1:ic+b1,a2+1:a2+b2)=B0;
    C0(ic+1:ic+b1,1:a2)=ones(b1,1)*A0(ia,:);
    ic=ic+b1;
end

C=C0;


