
function [y]=FW_CALCUL180529(X,Equation)
% [y]=FW_CALCUL180323(X,Equation) 
% This function applies the equation given
% in the input variable 'Equation' to 'X', a matrix of points to calculate.
% X is of dimension (n,nvar), where n is the number of points, and nvar the
% number of variables. The calculated values are returned in 'y'.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

M_coeff=Equation.coeff;
if size(M_coeff,1)==1
    M_coeff=M_coeff';
end
Model=Equation.Model;

[n,nvar]=size(X);
ncoeff=length(M_coeff);

Z=zeros(n,ncoeff);
for in=1:n

    Zi=1;

    for ivar=1:nvar        
        ZZi=FW_MakeX0529(X(in,ivar),Model{ivar});
        Zi=kron(Zi,ZZi);
    end
    
    Z(in,:)=Zi;
end

y=Z*M_coeff;

end



