function COINS=FW_COINS_HYPERCUBE_v2(Vm,VM)
%COINS=FW_COINS_HYPERCUBE_v2(Vm,VM)
% Builds an hypercube in nvar dimensions between Vm and VM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nvar=length(Vm);
% number of corners
ncoins=2^nvar;
% Corners of the hypercube
COINS=zeros(ncoins,nvar);
ke=1;
for ivar=1:nvar
    COINS(ke+1:ke+ke,:)=COINS(1:ke,:);
    COINS(ke+1:ke+ke,nvar+1-ivar)=1;
    ke=2*ke;
end

% if nargin==3
    COINS=ones(2^nvar,1)*Vm+COINS*diag(VM-Vm);
% end

