
function [ModelDeriv]=FW_M_derivee180529(Model)

% [ModelDeriv]=FW_M_derivee180429(Model);
% calculates the derivative of the function 'f_{j,v}'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% First Derivative
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
typekernel=Model.typekernel;
% if nargin < 2
%     typekernel='poly';
% end

exponents=Model.exponents;
ncoeff=length(exponents);

M_mult=Model.mult;

% polynomial type
if strcmp(typekernel,'poly') || strcmp(typekernel,'power')

    for ico=1:ncoeff
        % an exponent could be 0
        if exponents(ico) ~= 0
            % The multiplicative coeff is multiplied by the previous exponent
            M_mult(ico)=M_mult(ico)*exponents(ico);
            % The row is created
            exponents(ico)=exponents(ico)-1;
        else
            % The row is created
            exponents(ico)=0;
            % The multiplicative coeff is 0
            M_mult(ico)=0;
        end
    end
end
% exponential type
if strcmp(typekernel,'exp')
    M_mult=M_mult.*exponents';
end

ModelDeriv=Model;
ModelDeriv.exponents=exponents;
ModelDeriv.mult=M_mult;

end
