
function [ModelTensor]=FW_MakeF180429(Model)
% [ModelTensor]=FW_MakeTensor180429(Model)
% outputs the model built as the tensor product  of the functions
% 'f_{j,v}'. If certains terms are omitted in 'F_j', the resulting function
% may be different of 'F_j'.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nvar=length(Model);

% multiplicative coefficients
M_mult=1;
for ivar=1:nvar
    M_mult=kron(M_mult,Model{ivar}.mult);
end
if size(M_mult,1)==1
    M_mult=M_mult';
end

Falpha=Model{1}.exponents;
%(0:(length(Model{1}.exponents)-1))';
for ivar=2:nvar
    Falpha=FW_ADDTENSOR180323(Falpha,Model{ivar}.exponents);
end

ncoeff=1;
for ivar=1:nvar
    ncoeff=ncoeff*length(Model{ivar}.exponents);
end

tk=cell(1,nvar);
for ivar=1:nvar
    tk{ivar}=Model{ivar}.typekernel;
end

ModelTensor.exponents=Falpha;
ModelTensor.mult=M_mult;
ModelTensor.ncoeff=ncoeff;
ModelTensor.nvar=nvar;
ModelTensor.typekernel=tk;

% offset
offset=0;
for ivar=1:nvar
    if isfield(Model{ivar},'offset')
        offset=max(Model{ivar}.offset,offset);
    end
end
if offset >0
    ModelTensor.offset=offset;
end

end




