
function [Model]=FW_Makefj180429(ModelTensor)
% [Model]=FW_Makefj180429(ModelTensor)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nvar=ModelTensor.nvar;

% Models dimension 1
Model=cell(1,nvar);
for ivar=1:nvar
    Model{ivar}.exponents=unique(ModelTensor.exponents(:,ivar));
    Model{ivar}.ncoeff=length(Model{ivar}.exponents);
    Model{ivar}.mult=ones(1,Model{ivar}.ncoeff);
    Model{ivar}.typekernel=ModelTensor.typekernel{ivar};
    
    % offset
    if isfield(ModelTensor,'offset') 
        if strcmp(Model{ivar}.typekernel,'power')
            Model{ivar}.offset=ModelTensor.offset;
        end
    end

end