
function [Simplex]=FW_Simplex180529(Model,a0,b0)

%[Simplex]=FW_Simplex180429(Model,a0,b0)
% returns a structure 'simplex' describing the osculating simplex between
% a0 and b0.
% Model is a one dimensional elementary model
% a0, b0 are the limits 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

a=min([a0,b0]);
b=max([a0,b0]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Vertices 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
typekernel=Model.typekernel;
% Initial domain and Vertices of the initial simplex
if strcmp(typekernel,'poly' )
    Simplex=FW_Simploscpoly1_180405(Model,a,b);
end
if strcmp(typekernel,'exp')
    Simplex=FW_Simploscexp1_180323(Model,a,b);
end
if strcmp(typekernel,'power')
    Simplex=FW_Simploscpower1_180529(Model,a,b);
end

Simplex.Vtgtes=[a;b];

