
function [Simplex]=FW_Simploscpower1_180529(Model,a,b)

% [Sommets]=FW_Simploscpoly1(Model,a,b)
% osculating simplex between a and b for the power
% system of functions. Each line of the matrix 'Sommets' is a vertex.
% Their determination is based on a linear system of equations
% The result is returned only in the case of a well-conditionned system (<
% condAseuil)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if nargin==1
    a=0;
    b=1;
end

% a<=0 
if a==0 && Model.offset <= 0 
    fprintf('Error, FW_Simploscpower1_180529, offset <= 0  \n');
    Simplex=[];
    return
end

[Simplex]=FW_Simploscpoly1_180405(Model,a+Model.offset,b+Model.offset);
if ~isfield(Simplex,'Vertices')
    fprintf('ERROR FW_Simploscpower1_180529 : the returned simplex can not be calculated\n');
    return
end




    



