%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMPLEX REGRESSION F. WAHL, T. ESPINASSE, Simplex Regression:
% Multivariable Parametric Regression under Shape Constraints Lyon1
% University, 2018
% http://math.univ-lyon1.fr/homes-www/wahl/download/index.php?file=simplexregression.zip
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Part of the script for producing the figures ouput from
% FWMain_Simplex180429 in dimension one.
figure;
if strcmp(nomvrai,'hawkins')
    Xexp=Xexp_ori;
    plot(Xexp,yexp,'sr','MarkerFaceColor','g','MarkerSize',10);
    set(gca,'XLim',[Xexpm,XexpM]);
else
    plot(Xexp,yexp,'sr','MarkerFaceColor','g','MarkerSize',10);
    set(gca,'XLim',[0,1]);
end
hold on;
grid on;

pas=0.001;
if strcmp(nomvrai,'hawkins') %|| strcmp(nomvrai,'sigmoid')
    Xfonc=linspace(Xexpm,XexpM,1000)';
else
    Xfonc=(0:pas:1)';
%     if strcmp(Model{1}.typekernel,'power')
%         Xfonc=Xfonc(Xfonc >= Model{1}.offset);
%     end
end


nfonc=length(Xfonc);
X1=FW_MakeX0529(Xfonc,Model{1});

if strcmp(nomvrai,'hawkins')
    % without constraints
    Xmulti=FW_MakeX0529(Xexp,Model{1});
    bmulti=(Xmulti'*Xmulti)\(Xmulti'*yexp);
end

yhat=X1*bmulti;
% regression without constraints
plot(Xfonc,yhat,'--k','LineWidth',1);

switch(nomvrai)
    case('hawkins')
        M_coeff0=Equation0.coeff;
        Xf=Xfonc;
        yfonc=4*Xf.*(Xf-2).^2.*(Xf+0.5).^2.*(Xf.^2+2);
        % To compare the coefficients with those of Murray and Turlach
        % (degree 5)
        if strcmp(Model{1}.typekernel,'poly') && length(Model{1}.exponents)==6
            beta=[M_coeff0(6)/2^5
                5*M_coeff0(6)/2^5+M_coeff0(5)/2^4
                5*4/2*M_coeff0(6)/2^5+4*M_coeff0(5)/2^4+M_coeff0(4)/2^3
                10*M_coeff0(6)/2^5+6*M_coeff0(5)/2^4+3*M_coeff0(4)/2^3+M_coeff0(3)/2^2
                5*M_coeff0(6)/2^5+4*M_coeff0(5)/2^4+3*M_coeff0(4)/2^3+2*M_coeff0(3)/2^2+M_coeff0(2)/2
                M_coeff0(6)/2^5+M_coeff0(5)/2^4+M_coeff0(4)/2^3+M_coeff0(3)/2^2+M_coeff0(2)/2+M_coeff0(1)];
            
            beta=beta(6:-1:1);
        end
        % degre 4
        if strcmp(Model{1}.typekernel,'poly') && length(Model{1}.exponents)==5
            beta=[M_coeff0(5)/2^4
                4*M_coeff0(5)/2^4+M_coeff0(4)/2^3
                6*M_coeff0(5)/2^4+3*M_coeff0(4)/2^3+M_coeff0(3)/2^2
                4*M_coeff0(5)/2^4+3*M_coeff0(4)/2^3+2*M_coeff0(3)/2^2+M_coeff0(2)/2
                M_coeff0(5)/2^4+M_coeff0(4)/2^3+M_coeff0(3)/2^2+M_coeff0(2)/2+M_coeff0(1)];
            
            beta=beta(5:-1:1);
        end
        
        
end

% estimated predictions
if strcmp(nomvrai,'hawkins')
    yhat=FW_CALCUL180529((Xfonc+1)/2,Equation0);    
else
    yhat=FW_CALCUL180529(Xfonc,Equation0);
end

plot(Xfonc,yhat,'r','LineWidth',2);
switch(nomvrai)
    case('hawkins')
        title('hawkins function : y=4x(x-2)^2(x+0.5)^2(x^2+2)','FontSize',14,'FontWeight','bold');
%        title('hawkins data set','FontSize',14,'FontWeight','bold');
end
xlabel('x','FontSize',24);%,'FontWeight','bold');
ylabel('y','FontSize',24);%,'FontWeight','bold');
plot(Equationi{1}.Liste_Vtgte(:,1),0,'+b','LineWidth',2);
grid on;

